#include "libgraph.h"
#include <alloc.h>




/* Copy, Past */



value gr_copy(str)   /* ML */
  value str;
{
  char *s;
  int  len;

  gr_check_open();
  s=String_val(str);
  len=strlen(s);
  XStoreBytes(grdisplay,s,len);
  return Val_unit;
}


value gr_past()     /* ML */
{
  value s;
  char *tampon,*ptr;
  int len=0;

  gr_check_open();
  tampon=XFetchBytes(grdisplay,&len);
  if(tampon)
  {
     if(tampon[len-1]=='\0')
     {
        s=alloc_string(len-1);
        ptr=String_val(s);
        strcpy(ptr,tampon);
      }
      else
      { 
        s=alloc_string(len);
        ptr=String_val(s);
        *ptr = '\0';
        strncat(ptr,tampon,len);
      }
      XFree(tampon);
  }
  else
  {
    s=alloc_string(len);
    ptr=String_val(s);
    *ptr = '\0';
  }

  return s;
}

